Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.type
Class ErrorType

    java.lang.Object
      net.sf.saxon.type.ErrorType

All Implemented Interfaces:
  Serializable, SchemaComponent, SchemaType, SimpleType

    public final class ErrorType

extends Object
implements SimpleType

This class has a singleton instance which represents the XML Schema 1.1 built-in type xs:error

See Also:
  Serialized Form

Field Summary

Fields inherited from interface net.sf.saxon.type.SimpleType
`VARIETY_ATOMIC, VARIETY_LIST, VARIETY_UNION, VARIETY_UNSPECIFIED_SIMPLE`

Fields inherited from interface net.sf.saxon.type.SchemaType
`DERIVATION_EXTENSION, DERIVATION_LIST, DERIVATION_RESTRICTION, DERIVATION_UNION, DERIVE_BY_SUBSTITUTION`

Fields inherited from interface net.sf.saxon.type.SchemaComponent
`FIXED_UP, INCOMPLETE, INVALID, UNVALIDATED, VALIDATED, VALIDATING`

Method Summary
`boolean` | `allowsDerivation(int derivation)` Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
`void` | `analyzeContentExpression(Expression expression, int kind, StaticContext env)` Analyze an expression to see whether the expression is capable of delivering a value of this type.
`Value` | `atomize(NodeInfo node)` Get the typed value of a node that is annotated with this schema type.
`void` | `checkTypeDerivationIsOK(SchemaType type, int block)` Check that this type is validly derived from a given type
`SchemaType` | `getBaseType()` Get the base type
`int` | `getBlock()` Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`
`SchemaType` | `getBuiltInBaseType()` Get the built-in ancestor of this type in the type hierarchy
`int` | `getDerivationMethod()` Gets the integer code of the derivation method used to derive this type from its parent.
`String` | `getDescription()` Get a description of this type for use in diagnostics
`String` | `getDisplayName()` Get the display name of the type: that is, a lexical QName with an arbitrary prefix
`int` | `getFingerprint()` Get the fingerprint of the name of this type
`static ErrorType` | `getInstance()` Get the singular instance of this class
`SchemaType` | `getKnownBaseType()` Returns the base type that this type inherits from.
`String` | `getName()` Get the local name of this type
`int` | `getNameCode()` Get the namecode of the name of this type.
`int` | `getRedefinitionLevel()` Get the redefinition level.
`String` | `getSystemId()` Get the URI of the schema document containing the definition of this type
`String` | `getTargetNamespace()` Get the target namespace of this type
`SequenceIterator` | `getTypedValue(CharSequence value, NamespaceResolver resolver, ConversionRules rules)` Get the typed value corresponding to a given string value, assuming it is valid against this type
`SequenceIterator` | `getTypedValue(NodeInfo node)` Get the typed value of a node that is annotated with this schema type.
`int` | `getValidationStatus()` Get the validation status - always valid
`int` | `getWhitespaceAction()` Determine how values of this simple type are whitespace-normalized.
`boolean` | `isAnonymousType()` Test whether this is an anonymous type
`boolean` | `isAtomicType()` Test whether this Simple Type is an atomic type
`boolean` | `isBuiltInType()` Determine whether this is a built-in type or a user-defined type
`boolean` | `isComplexType()` Test whether this SchemaType is a complex type
`boolean` | `isExternalType()` Return true if this is an external object type, that is, a Saxon-defined type for external Java or .NET objects
`boolean` | `isIdRefType()` Ask whether this type is an IDREF or IDREFS type.
`boolean` | `isIdType()` Ask whether this type is an ID type.
`boolean` | `isListType()` Determine whether this is a list type
`boolean` | `isNamespaceSensitive()` Test whether this type represents namespace-sensitive content
`boolean` | `isSameType(SchemaType other)` Test whether this is the same type as another type.
`boolean` | `isSimpleType()` Test whether this SchemaType is a simple type
`boolean` | `isUnionType()` Determin whether this is a union type
`CharSequence` | `postprocess(CharSequence input)` Reverse any pre-lexical facets, other than whitespace.
`CharSequence` | `preprocess(CharSequence input)` Apply any pre-lexical facets, other than whitespace.
`ValidationFailure` | `validateContent(CharSequence value, NamespaceResolver nsResolver, ConversionRules rules)` Check whether a given input string is valid according to this SimpleType

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### getName

    public String getName()

  Get the local name of this type

  Specified by:
    `getName` in interface `SchemaType`
  Returns:
    the local name of this type definition, if it has one. Return null in the case of an anonymous type.

### getTargetNamespace

    public String getTargetNamespace()

  Get the target namespace of this type

  Specified by:
    `getTargetNamespace` in interface `SchemaType`
  Returns:
    the target namespace of this type definition, if it has one. Return null in the case of an anonymous type, and in the case of a global type defined in a no-namespace schema.

### isExternalType

    public boolean isExternalType()

  Return true if this is an external object type, that is, a Saxon-defined type for external Java or .NET objects

  Specified by:
    `isExternalType` in interface `SimpleType`
  Returns:
    true if this is an external type

### isBuiltInType

    public boolean isBuiltInType()

  Determine whether this is a built-in type or a user-defined type

  Specified by:
    `isBuiltInType` in interface `SimpleType`
  Returns:
    true if this is a built-in type

### getRedefinitionLevel

    public int getRedefinitionLevel()

  Get the redefinition level. This is zero for a component that has not been redefined; for a redefinition of a level-0 component, it is 1; for a redefinition of a level-N component, it is N+1. This concept is used to support the notion of "pervasive" redefinition: if a component is redefined at several levels, the top level wins, but it is an error to have two versions of the component at the same redefinition level.

  Specified by:
    `getRedefinitionLevel` in interface `SchemaComponent`
  Returns:
    the redefinition level

### getSystemId

    public String getSystemId()

  Get the URI of the schema document containing the definition of this type

  Specified by:
    `getSystemId` in interface `SchemaType`
  Returns:
    null for a built-in type

### getInstance

    public static ErrorType getInstance()

  Get the singular instance of this class

  Returns:
    the singular object representing xs:anyType

### getValidationStatus

    public int getValidationStatus()

  Get the validation status - always valid

  Specified by:
    `getValidationStatus` in interface `SchemaComponent`
  Returns:
    one of the values `SchemaComponent.UNVALIDATED`, `SchemaComponent.VALIDATING`, `SchemaComponent.VALIDATED`, `SchemaComponent.INVALID`, `SchemaComponent.INCOMPLETE`

### getBaseType

    public SchemaType getBaseType()

  Get the base type

  Specified by:
    `getBaseType` in interface `SchemaType`
  Returns:
    AnyType

### getKnownBaseType

    public SchemaType getKnownBaseType()
                                throws IllegalStateException

  Returns the base type that this type inherits from. This method can be used to get the base type of a type that is known to be valid.

  Returns:
    the base type.
  Throws:
    `IllegalStateException`

### isComplexType

    public boolean isComplexType()

  Test whether this SchemaType is a complex type

  Specified by:
    `isComplexType` in interface `SchemaType`
  Returns:
    true if this SchemaType is a complex type

### isSimpleType

    public boolean isSimpleType()

  Test whether this SchemaType is a simple type

  Specified by:
    `isSimpleType` in interface `SchemaType`
  Returns:
    true if this SchemaType is a simple type

### getFingerprint

    public int getFingerprint()

  Get the fingerprint of the name of this type

  Specified by:
    `getFingerprint` in interface `SchemaType`
  Returns:
    the fingerprint.

### getNameCode

    public int getNameCode()

  Get the namecode of the name of this type. This includes the prefix from the original type declaration: in the case of built-in types, there may be a conventional prefix or there may be no prefix.

  Specified by:
    `getNameCode` in interface `SchemaType`
  Returns:
    the namecode. Returns an invented namecode for an anonymous type.

### getDescription

    public String getDescription()

  Get a description of this type for use in diagnostics

  Specified by:
    `getDescription` in interface `SchemaType`
  Returns:
    the string "xs:anyType"

### getDisplayName

    public String getDisplayName()

  Get the display name of the type: that is, a lexical QName with an arbitrary prefix

  Specified by:
    `getDisplayName` in interface `SchemaType`
  Returns:
    a lexical QName identifying the type

### isSameType

    public boolean isSameType(SchemaType other)

  Test whether this is the same type as another type. They are considered to be the same type if they are derived from the same type definition in the original XML representation (which can happen when there are multiple includes of the same file)

  Specified by:
    `isSameType` in interface `SchemaType`
  Parameters:
    `other` - the other type
  Returns:
    true if this is the same type as other

### getTypedValue

    public SequenceIterator getTypedValue(NodeInfo node)

  Get the typed value of a node that is annotated with this schema type. This shouldn't happen: nodes are never annotated as xs:error; but if it does happen, we treat it as if it were untypedAtomic.

  Specified by:
    `getTypedValue` in interface `SchemaType`
  Parameters:
    `node` - the node whose typed value is required
  Returns:
    an iterator returning a single untyped atomic value, equivalent to the string value of the node.

### atomize

    public Value atomize(NodeInfo node)

  Get the typed value of a node that is annotated with this schema type. The result of this method will always be consistent with the method `getTypedValue(net.sf.saxon.om.NodeInfo)`. However, this method is often more convenient and may be more efficient, especially in the common case where the value is expected to be a singleton.

  Specified by:
    `atomize` in interface `SchemaType`
  Parameters:
    `node` - the node whose typed value is required
  Returns:
    the typed value.
  Since:
    8.5

### checkTypeDerivationIsOK

    public void checkTypeDerivationIsOK(SchemaType type,
                                        int block)
                                 throws SchemaException

  Check that this type is validly derived from a given type

  Specified by:
    `checkTypeDerivationIsOK` in interface `SchemaType`
  Parameters:
    `type` - the type from which this type is derived
    `block` - the derivations that are blocked by the relevant element declaration
  Throws:
    `SchemaException` - if the derivation is not allowed

### isAtomicType

    public boolean isAtomicType()

  Test whether this Simple Type is an atomic type

  Specified by:
    `isAtomicType` in interface `SchemaType`
  Specified by:
    `isAtomicType` in interface `SimpleType`
  Returns:
    false, this is not (necessarily) an atomic type

### isIdType

    public boolean isIdType()

  Ask whether this type is an ID type. This is defined to be any simple type who typed value may contain atomic values of type xs:ID: that is, it includes types derived from ID by restriction, list, or union. Note that for a node to be treated as an ID, its typed value must be a *single* atomic value of type ID; the type of the node, however, can still allow a list.

  Specified by:
    `isIdType` in interface `SchemaType`
  Returns:
    true if this type is an ID type

### isIdRefType

    public boolean isIdRefType()

  Ask whether this type is an IDREF or IDREFS type. This is defined to be any simple type who typed value may contain atomic values of type xs:IDREF: that is, it includes types derived from IDREF or IDREFS by restriction, list, or union

  Specified by:
    `isIdRefType` in interface `SchemaType`
  Returns:
    true if this type is an IDREF type

### isAnonymousType

    public boolean isAnonymousType()

  Description copied from interface: `SchemaType`
  Test whether this is an anonymous type

  Specified by:
    `isAnonymousType` in interface `SchemaType`
  Returns:
    true if this SchemaType is an anonymous type

### isListType

    public boolean isListType()

  Determine whether this is a list type

  Specified by:
    `isListType` in interface `SimpleType`
  Returns:
    false (it isn't a list type)

### isUnionType

    public boolean isUnionType()

  Determin whether this is a union type

  Specified by:
    `isUnionType` in interface `SimpleType`
  Returns:
    true (this is a union type with no members)

### getBuiltInBaseType

    public SchemaType getBuiltInBaseType()

  Get the built-in ancestor of this type in the type hierarchy

  Specified by:
    `getBuiltInBaseType` in interface `SimpleType`
  Returns:
    xs:anySimpleType

### getTypedValue

    public SequenceIterator getTypedValue(CharSequence value,
                                          NamespaceResolver resolver,
                                          ConversionRules rules)

  Get the typed value corresponding to a given string value, assuming it is valid against this type

  Specified by:
    `getTypedValue` in interface `SimpleType`
  Parameters:
    `value` - the string value
    `resolver` - a namespace resolver used to resolve any namespace prefixes appearing in the content of values. Can supply null, in which case any namespace-sensitive content will be rejected.
    `rules` -
  Returns:
    an iterator over the atomic sequence comprising the typed value. The objects returned by this SequenceIterator will all be of type `AtomicValue`

### validateContent

    public ValidationFailure validateContent(CharSequence value,
                                             NamespaceResolver nsResolver,
                                             ConversionRules rules)

  Check whether a given input string is valid according to this SimpleType

  Specified by:
    `validateContent` in interface `SimpleType`
  Parameters:
    `value` - the input string to be checked
    `nsResolver` - a namespace resolver used to resolve namespace prefixes if the type is namespace sensitive. The value supplied may be null; in this case any namespace-sensitive content will throw an UnsupportedOperationException.
    `rules` -
  Returns:
    null if validation succeeds (which it never does for this implementation)
  Throws:
    `UnsupportedOperationException` - if the type is namespace-sensitive and no namespace resolver is supplied

### isNamespaceSensitive

    public boolean isNamespaceSensitive()

  Test whether this type represents namespace-sensitive content

  Specified by:
    `isNamespaceSensitive` in interface `SimpleType`
  Returns:
    false

### getBlock

    public int getBlock()

  Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`

  Specified by:
    `getBlock` in interface `SchemaType`
  Returns:
    the value of the 'block' attribute for this type

### getDerivationMethod

    public int getDerivationMethod()

  Gets the integer code of the derivation method used to derive this type from its parent. Returns zero for primitive types.

  Specified by:
    `getDerivationMethod` in interface `SchemaType`
  Returns:
    a numeric code representing the derivation method, for example `SchemaType.DERIVATION_RESTRICTION`

### allowsDerivation

    public boolean allowsDerivation(int derivation)

  Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property

  Specified by:
    `allowsDerivation` in interface `SchemaType`
  Parameters:
    `derivation` - the kind of derivation, for example `SchemaType.DERIVATION_LIST`
  Returns:
    true if this kind of derivation is allowed

### getWhitespaceAction

    public int getWhitespaceAction()

  Determine how values of this simple type are whitespace-normalized.

  Specified by:
    `getWhitespaceAction` in interface `SimpleType`
  Returns:
    one of `Whitespace.PRESERVE`, `Whitespace.COLLAPSE`, `Whitespace.REPLACE`.

### analyzeContentExpression

    public void analyzeContentExpression(Expression expression,
                                         int kind,
                                         StaticContext env)
                                  throws XPathException

  Analyze an expression to see whether the expression is capable of delivering a value of this type.

  Specified by:
    `analyzeContentExpression` in interface `SchemaType`
  Parameters:
    `expression` - the expression that delivers the content
    `kind` - the node kind whose content is being delivered: `Type.ELEMENT`, `Type.ATTRIBUTE`, or `Type.DOCUMENT`
    `env` -
  Throws:
    `XPathException` - if the expression will never deliver a value of the correct type

### preprocess

    public CharSequence preprocess(CharSequence input)

  Apply any pre-lexical facets, other than whitespace. At the moment the only such facet is saxon:preprocess

  Specified by:
    `preprocess` in interface `SimpleType`
  Parameters:
    `input` - the value to be preprocessed
  Returns:
    the value after preprocessing

### postprocess

    public CharSequence postprocess(CharSequence input)
                             throws ValidationException

  Reverse any pre-lexical facets, other than whitespace. At the moment the only such facet is saxon:preprocess. This is called when converting a value of this type to a string

  Specified by:
    `postprocess` in interface `SimpleType`
  Parameters:
    `input` - the value to be postprocessed: this is the "ordinary" result of converting the value to a string
  Returns:
    the value after postprocessing
  Throws:
    `ValidationException` - if postprocessing detects that the value is invalid

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.